package test;

import edu.neu.ccs.demeterf.http.classes.HTTPReq;
import edu.neu.ccs.demeterf.http.classes.HTTPResp;
import edu.neu.ccs.demeterf.lib.List;
import java.io.FileInputStream;
import player.PlayerServer;
import player.PlayerFactory;
import scg.gen.PlayerContext;
import logging.Logger;

/** A Little Player Test */
public class PlayerTest {

    /** Where the PlayerServer will be */
    static final String TEST_SERVER = "127.0.0.1";
    static void pe(String s){ System.err.print(s); }
    static void p(String s){ System.out.print(s); }

    /** Simple Test Main */
    public static void main(String[] args) throws Exception{
        if (args.length < 3) {
            pe(" ! Usage: java PlayerTest <Context File> <Server> <Port>\n");
            return;
        }
        //direct(args);
        indirect(args);
    }
    /** Contact the Player via HTTP/Sockets */
    public static void indirect(String[] args) throws Exception{
        String file = args[0];

        PlayerContext ctx = PlayerContext.parse(new FileInputStream(file));
        HTTPReq req = HTTPReq.Post(PlayerServer.EntryPath, ctx.toString());
        HTTPResp res = req.send(args[1], Integer.parseInt(args[2]), 0);
        //p(" Result: \n" + res.getBodyString());
    }
    
    /** Contact the Player directly */
    public static void direct(String[] args) throws Exception{
        PlayerContext ctx = PlayerContext.parse(new FileInputStream(args[0]));
        PlayerFactory fact = PlayerFactory.create(List.create(args));
        System.out.println(
        fact.getAPlayer(ctx, Logger.text(System.out)).play()//;
        );
    }

}
